<template xmlns:input="http://www.w3.org/1999/html">
  <div>
    <div class="padding">
      <div class="row">
        <div class="columns three">
          <span v-if="cardWithAttr.editable" v-show="true" class="edit" @keydown="inputHandler" @click="startEditName" @blur="setName" :contenteditable="editingName" ref="namefield" >{{ cardWithAttr.card.name }}</span>
          <span v-else >{{ cardWithAttr.card.name }}</span>
        </div>
        <div class="columns one card-icon">
          <img :src="`/lk/static/img/my-accounts/${cardWithAttr.img}`" :style="cardWithAttr.card.activated ? '' : 'filter: grayscale(100%)'" alt="" class="a-image">
        </div>
        <div class="columns three card-text">
          {{ cardWithAttr.card.description }}
        </div>
        <div v-if="cardWithAttr.card.activated" class="columns four">
          <span v-if="cardWithAttr.card.main" v-html="msg" class="prima-card">
          </span>
          <a v-else @click="makePrimary" class="prima-card">Сделать основной</a>
        </div>
        <div v-else class="columns four">
          <span class="card-warning">Карта не привязана. <a href="#" @click.prevent="newCard">Привязать</a></span>
        </div>
        <div class="columns one right-adaptive">
          <a v-if="cardWithAttr.deletable" href="#" class="delete" @click.prevent="showModal(cardWithAttr.card)"><span>Удалить</span></a>
        </div>
      </div>
    </div>
    <hr>
  </div>
</template>

<script>
  import {getPaySystemText} from '@/utils/mappings/accounts'

  export default {
    name: 'card-component',
    props: {
      cardWithAttr: {
        type: Object,
        required: true
      }
    },
    data () {
      return {
        editingName: false
      }
    },
    computed: {
      msg () {
        switch (getPaySystemText(this.cardWithAttr.card.type)) {
          case 'Контакт':
            return `Выдача наличными в <a href="https://www.contact-sys.com/where/point/WBRV/0/list/0/0/" target="_blank">пункте выдачи</a>`
          case 'Карта':
            return 'Займ будет выдан на эту карту'
          case 'Яндекс кошелёк':
            return 'Займ будет выдан на этот кошелёк'
        }
        return 'Займ будет выдан на эту карту'
      }
    },
    mounted () {
    },
    methods: {
      startEditName () {
        this.editingName = true
        const field = this.$refs.namefield
        setTimeout(() => field.focus(), 0)
      },
      setName (event) {
        this.$store.dispatch('ACCOUNTS_SET_NAME', {...this.cardWithAttr.card, name: event.target.innerHTML})
      },
      inputHandler (event) {
        if (event.keyCode === 13) { // По энтеру эмитим блюр, а блюр запустит setName
          event.target.blur(event)
        }
      },
      showModal (card) {
        const params = {
          title: getPaySystemText(card.type) === 'Карта' ? 'Удаление карты' : 'Удаление кошелька',
          questionText: `Вы действительно хотите удалить ${getPaySystemText(card.type) === 'Карта' ? 'карту' : 'кошелек'} ${this.cardWithAttr.card.description}?`,
          action: 'ACCOUNTS_DELETE_ACCOUNT',
          card
        }
        this.$parent.$modal.show('delete-account', params)
      },
      makePrimary () {
        const params = {
          title: 'Изменение основного счёта',
          questionText: 'Вы точно хотите изменить основной счёт?',
          action: 'ACCOUNTS_SET_PRIMARY',
          card: this.cardWithAttr.card
        }
        this.$parent.$modal.show('delete-account', params)
      },
      newCard () {
        this.$parent.$modal.show('new-card')
      }
    }
  }
</script>

<style scoped>
  .blinking {
    animation: blink .3s ease-in-out;
  }

  @keyframes blink {
    0% {
      background-color: #6ac651;
    }
    100% {
      background-color: none;
    }
  }

  .card-warning {
    color: #989898;
    display: inline-block;
    min-height: 20px;
    background: url(/lk/static/img/my-accounts/warning.png) no-repeat 0 50%;
    padding-left: 30px;
    line-height: 20px;
  }

  input[type="text"] {
    border: 0px;
    padding: 0px;
    margin: 0px;
    height: auto;
    width: 100%;
  }
</style>
